
//  #####################################################################
//  DC_ACHOICE_MENU.prg
//  28-04-2025
//
//  I really like Roger's function DC_GuiAchoice()
//  so I tried to adapt it to windows 11
//
//  www.cobasystems.com, COBA Systems, Slobodan Stanojevi Coba
//  Alaska Xbase++ version 2.0.1503, eXpress++ version 2.0.268
//  #####################################################################

#include "Appevent.ch"
#include "Common.ch"
#include "Xbp.ch"
#include "xbtsys.ch"

#INCLUDE "DCDIALOG.CH"


PROCEDURE APPSYS()
RETURN


*************************************************************************
PROCEDURE MAIN()
*************************************************************************
LOCAL cTitle, lCenter, cFontName, aMenuItems, nn

SET DATE GERMAN
SET CENTURY ON
SET CHARSET TO ANSI


  DC_ICONDEFAULT(1) // DEMO.RES

  cTitle       := "NBS WEB SERVICE | Narodna Banka Srbije | Soap Web servis"
  lCenter      := .T.
  cFontName    := "10.Verdana" // "11.Consolas"
  aMenuItems   := {" " ,; // 1
                   "NBS KURSNA LISTA TRENUTNA (CURRENT)         " ,; // 2
                   "1. DEVIZE   Kupovni-prodajni kurs           " ,; // 3  NBS_GetCurrentExchangeRate.PRG
                   "2. EFEKTIVA Kupovni-srednji-prodajni kurs   " ,; // 4  NBS_GetCurrentExchangeRate.PRG
                   "3. SREDNJI  Srednji kurs                    " ,; // 5  NBS_GetCurrentExchangeRate.PRG
                   " " ,; // 6
                   "NBS KURSNA LISTA ZA ZADATU GODINU           " ,; // 7
                   "4. DEVIZE   Kupovni-prodajni kurs           " ,; // 8  NBS_GetExchangeRateByCurrency.PRG
                   "5. EFEKTIVA Kupovni-srednji-prodajni kurs   " ,; // 9  NBS_GetExchangeRateByCurrency.PRG
                   "6. SREDNJI  Srednji kurs                    " ,; // 10 NBS_GetExchangeRateByCurrency.PRG
                   " " ,; // 11
                   "NBS IFARNICI BANAKA, FIRMI, VALUTA, DRAVA " ,; // 12
                   "BANKE                                       " ,; // 13 NBS_GetBank.PRG
                   "FIRME PO NAZIVU I MESTU                     " ,; // 14 NBS_GetCompany.PRG
                   "FIRME PO MBR I PIB                          " ,; // 15 NBS_GetCompany_MBR_PIB.PRG
                   "VALUTE                                      " ,; // 16 NBS_GetCurrency.PRG
                   "DRAVE                                      " ,; // 17 NBS_GetCountry.PRG
                   " " ,; // 18
                   "NBS KURS ZA ZADATU VALUTU PREMA DINARU"       ,; // 19
                   "7. Kurs EUR prema RSD trenutni              " ,; // 20 NBS_GetCurrentExchangeRateRsdEur.PRG
                   "8. Kurs EUR prema RSD za zadati datum       " ,; // 21 NBS_GetExchangeRateRsdEur.PRG
                   "9. Kurs EUR prema RSD za zadati period      " ,; // 22 NBS_GetExchangeRateRsdEurByPeriod.PRG
                   " ",; // 23
                   "Exit",;                                          // 24
                   " ",;  // 25
                   " "}


  DO WHILE .T.


  ******************************************************************

   PUBLIC oBrowse := NIL  // Formed in DC_GUIACHOICE.PRG - DC_GuiAchoice()

     nn := DC_GuiAchoice( (5),(10), (20+12), (30+20), aMenuItems,,,,,cTitle,,,cFontName )


     // Full:
     //  nn := DC_GuiAchoice( (5),(10), (20+12), (30+20),;
     //        aMenuItems ,;
     //        NIL ,; // aSelItems      ,;
     //        NIL ,; // cUserFunc      ,;
     //        NIL ,; // nInitialItems  ,;
     //        NIL ,; // nWindowRow     ,;
     //        cTitle ,;
     //        NIL ,; // aHelpCodes     ,;
     //        NIL ,; // aMenu          ,;
     //        cFontName ,;
     //        NIL ,; // @oDlg          ,;
     //        NIL ,; // lDestroy       ,;
     //        NIL ,; // aMessage       ,;
     //        NIL ,; // cHeader        ,;
     //        lCenter )  // -> nElement

  ******************************************************************


    * -------------------
      if nn=3
         prg(nn)
      endif
      if nn=4
         prg(nn)
      endif
      if nn=5
         prg(nn)
      endif
    * -------------------

    * -------------------
      if nn=8
         prg(nn)
      endif
      if nn=9
         prg(nn)
      endif
      if nn=10
         prg(nn)
      endif
    * -------------------

    * -------------------
      if nn=13
         prg(nn)
      endif
      if nn=14
         prg(nn)
      endif
      if nn=15
         prg(nn)
      endif
      if nn=16
         prg(nn)
      endif
      if nn=17
         prg(nn)
      endif
    * -------------------

    * -------------------
      if nn=20
         prg(nn)
      endif
      if nn=21
         prg(nn)
      endif
      if nn=22
         prg(nn)
      endif
    * -------------------

      if nn=24
         prg(nn,"[Exit] button")
         RETURN
      endif
      if nn=0
         prg(nn,"[Esc] key or [x] button/cancel")
         RETURN
      endif


  ENDDO


RETURN


STATIC FUNCTION prg(nn,ccomand)
default nn to 0, ccomand to "START"

    aItem := oBrowse:getdata()
    cItem := aItem[1]
    cItem:=alltrim(cItem)

    confirmbox(,ccomand + chr(13)+;
                "Program (item - row) = "+var2char(nn)+chr(13)+;
                cItem,"OK",XBPMB_OK, XBPMB_INFORMATION)

RETURN NIL





