/*
 ķ
   Program..: _DCACHOI.PRG                                     
   Author...: Roger J. Donnay                                  
   Notice...: (c) DONNAY Software Designs 1987-2001            
   Date.....: Mar 27, 2001                                     
   Notes....: Moused replacement for ACHOICE()                 
   Functions:  dc_achoice(), dc_readapick(), dc_guiachoice()   
 Ľ
*/

#include 'dcdialog.ch'
#include "SET.CH"
#include "INKEY.CH"
#include "DCCOLOR.CH"
#include "appevent.ch"
#include "xbp.ch"

#define nSTROW     aChoice[1]
#define nSTCOL     aChoice[2]
#define nENROW     aChoice[3]
#define nENCOL     aChoice[4]
#define lSTUFF     aChoice[5]
#define nSELROW    aChoice[6]
#define lUP        aChoice[7]
#define lDOWN      aChoice[8]
#define lHIT       aChoice[9]
#define nWAIT      aChoice[10]
#define cVALUE     aChoice[11]
#define nLENGTH    aChoice[12]
#define lENTER     aChoice[13]
#define aKEYS      aChoice[14]

#define AC_IDLE       0
#define AC_HITTOP     1
#define AC_HITBOTTOM  2
#define AC_EXCEPT     3
#define AC_NOITEM     4

#define AC_ABORT      0
#define AC_SELECT     1
#define AC_CONT       2
#define AC_GOTO       3
#define AC_CALLUDF    4

#define AC_ITEMS_COLOR       aCOLOR[1]
#define AC_HILITE_COLOR      aCOLOR[2]
#define AC_FRAME_COLOR       aCOLOR[3]
#define AC_UNUSED_COLOR      aCOLOR[4]
#define AC_NONAVAIL_COLOR    aCOLOR[5]

#define lSCROLLBAR           aOptions[1]
#define aCOLOR               aOptions[2]
#define cTITLE               aOptions[3]
#define lDRAGENABLE          aOptions[4]
#define lRESTSCREEN          aOptions[5]
#define lEXPLODE             aOptions[6]
#define lEXIT                aOptions[7]
#define lMOUSEEXIT           aOptions[8]


MEMVAR dCCOLOR

FUNCTION dc_achoice ( nTop, nLeft, nBottom, nRight, aMenuItems, ;
                      aSelectItems, cUserFunction, nElement,;
                      nWinStart, aHotKeys, aOptions, aHelpCodes, ;
                      aMenu, lAttachMenu, oObject, lCenter, lModal )

LOCAL nCursor, lPaintScrn, nInkey, nRow, i, cHelpCode, cBarHotKeys, ;
      cSaveData, nSaveRow, cSaveScrn, cSaveColor, aMouseMenu, ;
      nSaveElement, nStartScan, nState, nUdfReturn, cFunction, ;
      nMouseRow, nMouseCol, nSaveCurRow, nSaveCurCol, lMouVisible, ;
      cCode, aMainMenu, aMenuMain, cMenuColor, cScanString

LOCAL aChoice := { 0,0,0,0,.f.,0,.f.,.f.,.f.,1,'',0,.f.,{} }

nTop        := iif(valtype(nTop)='N',nTop,0)
nBottom     := iif(valtype(nBottom)='N',nBottom,MaxRow())
nLeft       := iif(valtype(nLeft)='N',nLeft,0)
nRight      := iif(valtype(nRight)='N',nRight,MaxCol())
nElement    := iif(valtype(nElement)='N',nElement,1)
nWinStart   := iif(valtype(nWinStart)='N',nWinStart,1)
aHotKeys    := iif(valtype(aHotkeys)='A',aHotkeys,{})
aOptions    := iif(valtype(aOptions)='A',aOptions,{})
lAttachMenu := iif(valtype(lAttachMenu)='L',lAttachMenu,.t.)

ASIZE(aOptions,10)
IF Valtype(aMenu)='A'
  nTop++
ENDIF

lSCROLLBAR  := IIF(VALTYPE(aOptions[1])='L',aOptions[1],.f.)
cTITLE      := IIF(VALTYPE(aOptions[3])='C',aOptions[3],'')
lDRAGENABLE := IIF(VALTYPE(aOptions[4])='L',aOptions[4],.f.)
lRESTSCREEN := IIF(VALTYPE(aOptions[5])='L',aOptions[5],.t.)
lEXPLODE    := IIF(VALTYPE(aOptions[6])='L',aOptions[6],.t.)
lEXIT       := IIF(VALTYPE(aOptions[7])='L',aOptions[7],.f.)
lMOUSEEXIT  := IIF(VALTYPE(aOptions[8])='L',aOptions[8],.f.)

cBarHotKeys := ''
cCode := ''
nMouseCol := 0
nMouseRow := 0
nState := AC_IDLE
nSELROW := 1
nWAIT := .3
lSTUFF := .f.
nLENGTH := LEN(aMenuItems)
aKEYS := aHotKeys
nUdfReturn := AC_CONT
IF VALTYPE(aSelectItems) # 'A'
  aSelectItems :=  ARRAY(LEN(aMenuItems))
  AFILL(aSelectItems,.t.)
ENDIF

************************************************************************************************* COBA

IF DC_Gui()

  nTop *= 20
  nBottom *= 20
  nLeft *= 10
  nRight *= 10

  RETURN DC_GuiAchoice ( nTop, nLeft, nBottom, nRight, aMenuItems, ;
                         aSelectItems, cUserFunction, nElement,;
                         nWinStart, cTITLE, aHelpCodes, aMenu,;
                         '10.Courier', @oObject, lRESTSCREEN,,, lCenter, lModal )

ENDIF

*************************************************************************************************


IF SetAppWindow():IsDerivedFrom('XbpCrt')
  nCursor     := SET(_SET_CURSOR)
  nSaveCurRow := ROW()
  nSaveCurCol := COL()
  cSaveColor := DC_SETCOLOR()
ENDIF
IF lSCROLLBAR
  IF VALTYPE(aCOLOR)#'A'
    aCOLOR := ARRAY(5)
    AC_ITEMS_COLOR     := cC_BRMENUD
    AC_FRAME_COLOR     := cC_BRMENUF
    AC_NONAVAIL_COLOR  := cC_BRMENUH
    AC_HILITE_COLOR    := cC_BRMENUS
  ENDIF
  IF lEXPLODE
    cSaveScrn := ;
     DC_EXPLODE( nTop, nLeft, nBottom, nRight, AC_FRAME_COLOR, AC_ITEMS_COLOR )
    DC_COLOR( AC_FRAME_COLOR )
    @nTop, nLeft+2 SAY '[]'
    @nBottom, nLeft+2 SAY ;
       PAD( '[ '+CHR(24)+' '+CHR(25)+' '+CHR(30)+' '+CHR(31)+' ]', ;
       MIN(nRight-nLeft-4,11) )
    @nTop, nRight-2 TO nBottom, nRight-2
    @nTop,nRight-2 SAY CHR(194)
    @nBottom,nRight-2 SAY CHR(193)
    @nTop+1,nRight-1 SAY CHR(24) COLOR 'W/N'
    @nBottom-1,nRight-1 SAY CHR(25) COLOR 'W/N'
  ENDIF
  IF !EMPTY(cTITLE)
    DC_COLOR( AC_FRAME_COLOR )
    @ nTop, nLeft+5 TO nTop, nRight-1
    DC_SAYCENTER( nTop, nLeft+4, nRight, '[ '+cTITLE+' ]' )
  ENDIF
  IF !lEXIT
    ASIZE( aHotKeys, LEN(aHotKeys) + 7 )
    FOR i := 1 TO 7
      aHotKeys := AINS( aHotKeys, 1 )
    NEXT
    aHotKeys[1] := {nTop,nLeft+3,,,K_ESC}
    aHotKeys[2] := {nBottom,nLeft+4,,,K_UP,,.1}
    aHotKeys[3] := {nTop+1,nRight-1,,,K_UP,,.1}
    aHotKeys[4] := {nBottom,nLeft+6,,,K_DOWN,,.1}
    aHotKeys[5] := {nBottom-1,nRight-1,,,K_DOWN,,.1}
    aHotKeys[6] := {nBottom,nLeft+8,,,K_PGUP,,.2}
    aHotKeys[7] := {nBottom,nLeft+10,,,K_PGDN,,.2}
  ENDIF
  SETCOLOR( cC_BRMENUD+','+cC_BRMENUS )
  nSTROW := nTop+1
  nSTCOL := nLeft+1
  nENROW := nBottom-1
  nENCOL := nRight-3
ELSE
  nSTROW := nTop
  nSTCOL := nLeft
  nENROW := nBottom
  nENCOL := nRight
  IF VALTYPE(aCOLOR)#'A'
    aCOLOR := DC_COLOR2ARRAY()
  ENDIF
ENDIF
IF Valtype(aMenu)='A'
  aMouseMenu := {}
  IF lAttachMenu
    aMenuMain := ACLONE(aMenu)
    aMenuMain[1] := nTop-1
    aMenuMain[2] := nLeft
    aMenuMain[4] := 'AAD'
    cMenuColor := DC_TOKEN(aMenuMain[3],',',2)
  ELSE
    aMenuMain := aMenu
  ENDIF
  IF Empty(cMenuColor)
    cMenuColor  := Left( cC_POPMENI, at( ",", cC_POPMENI ) - 1 )
  ENDIF
  SetColor(cMenuColor)
  @ nTop-1,nLeft CLEAR TO nTop-1,nRight
  DC_MenuMain( aMenuMain,,.t.,@aMouseMenu, @cBarHotKeys )
  FOR i := 1 TO LEN(aMouseMenu)
    AADD( aHotKeys, aMouseMenu[i] )
  NEXT
ENDIF
lPaintScrn := .t.
nInkey := 13
SET CURSOR OFF
cScanString := ''
DO WHILE .t.
  IF nElement > nLENGTH
    nElement := nLENGTH
    lPaintScrn := .t.
  ELSEIF nElement < 1
    nElement := 1
    lPaintScrn := .t.
  ENDIF
  IF nElement = nLENGTH
    nWinStart := nElement-(nENROW-nSTROW)
    lPaintScrn := .t.
  ENDIF
  IF nWinStart > nElement
    nWinStart := nElement
    lPaintScrn := .t.
  ELSEIF nWinStart > nLENGTH
    nWinStart := nLENGTH
    lPaintScrn := .t.
  ELSEIF nWinStart < 1
    nWinStart := 1
    lPaintScrn := .t.
  ELSEIF nWinStart < nElement-(nENROW-nSTROW)
    nWinStart := nElement-(nENROW-nSTROW)
    lPaintScrn := .t.
  ENDIF
  nRow := nSTROW+(nElement-nWinStart)
  IF lPaintScrn
    nSaveRow := nRow
    nSaveElement := nElement
    DC_COLOR( AC_ITEMS_COLOR )
    nRow := nSTROW
    nElement := nWinStart
    DC_DISPBEGIN()
    @ nSTROW,nSTCOL CLEAR TO nENROW,nENCOL
    DO WHILE .t.
      IF nRow > nENROW .OR. nElement > nLENGTH .OR. nLENGTH=0
        EXIT
      ENDIF
      DC_COLOR( AC_ITEMS_COLOR )
      IF (VALTYPE(aSelectItems[nElement])='L' .AND. ;
           !(aSelectItems[nElement])) .OR. ;
         (VALTYPE(aSelectItems[nElement])='C' .AND. ;
           !(&(aSelectItems[nElement])))
          DC_COLOR( AC_NONAVAIL_COLOR )
      ENDIF
      @ nRow,nSTCOL SAY ;
        PAD(TRANSFORM(aMenuItems[nElement],'@S'),nENCOL-nSTCOL+1)
      nRow++
      nElement++
    ENDDO
    DC_DISPEND()
    nRow := nSaveRow
    nElement := nSaveElement
    lPaintScrn := .f.
    IF nElement>0 .AND. nLENGTH>0
      cSaveData := PAD(TRANSFORM(aMenuItems[nElement],'@S'),nENCOL-nSTCOL+1)
    ENDIF
  ENDIF
  IF lSCROLLBAR
    DC_COLOR( AC_FRAME_COLOR )
    DC_SCRLVBAR( nSTROW+1, nENROW-1, nENCOL+2, nElement, 0, nLENGTH )
  ENDIF
  IF nLENGTH > 0
    DC_COLOR( AC_ITEMS_COLOR )
    IF nRow#nSaveRow
      @ nSaveRow,nSTCOL SAY cSaveData
    ENDIF
    cSaveData := PAD(TRANSFORM(aMenuItems[nElement],'@S'),nENCOL-nSTCOL+1)
    DC_COLOR( AC_HILITE_COLOR, .t. )
    @ nRow,nSTCOL SAY cSaveData
  ENDIF

  DO CASE
    CASE VALTYPE( cUserFunction ) = 'C'
      cFunction := STRTRAN( cUserFunction, '(', '' )
      cFunction := STRTRAN( cUserFunction, ')', '' )
      cFunction := cUserFunction + '(' + ALLTRIM(STR(nState)) + ',' + ;
       ALLTRIM(STR(nElement)) + ',' + ALLTRIM(STR(nRow-nSTROW)) + ')'
      nUdfReturn := &cFunction
    CASE VALTYPE( cUserFunction ) = 'B'
      nUdfReturn := EVAL(cUserFunction,nState,nElement,nWinStart)
  ENDCASE
  IF !EMPTY(cUserFunction)

    DO CASE
      CASE nUdfReturn = AC_SELECT
        nInkey := K_ENTER
        nState := AC_EXCEPT
      CASE nUdfReturn = AC_ABORT
        nInkey := K_ESC
        nState := AC_EXCEPT
      CASE nUdfReturn = AC_CONT
        nState := AC_IDLE
        nInkey := 0
    ENDCASE
  ENDIF
  IF nState = AC_IDLE .AND. !lEXIT
    IF Valtype(aHelpCodes)='A'
      cHelpCode := aHelpCodes[nElement]
    ENDIF
    nInkey := DC_INKEY(,0,@nMouseRow,@nMouseCol,,,,,,cHelpCode)
    cCode  := IIF(nInkey<32,'',UPPER(DC_CHRINKEY(nInkey)))
  ENDIF
  nState := AC_IDLE
  nSaveRow := nRow
  DC_COLOR( AC_ITEMS_COLOR )

  DO CASE

    CASE nLENGTH = 0
      EXIT

    CASE nInkey <= -101 .AND. nMouseRow >= nSTROW .AND. nMouseRow <= nENROW ;
                        .AND. nMouseCol >= nSTCOL .AND. ;
                             nMouseCol <= nENCOL
      nSaveElement := nElement
      nElement := nElement - (nRow-nMouseRow)
      IF nElement > nLENGTH .OR. nElement < 1
        nElement := nSaveElement
      ELSE
        IF (VALTYPE(aSelectItems[nElement])='L' .AND. ;
           !(aSelectItems[nElement])) .OR. ;
          (VALTYPE(aSelectItems[nElement])='C' .AND. ;
           !(&(aSelectItems[nElement])))
          nElement := nSaveElement
        ELSE
          IF nInkey = -104
            KEYBOARD CHR(13)
          ENDIF
        ENDIF
      ENDIF

    CASE nInkey <= -101 .AND. nMouseRow > nSTROW .AND. nMouseRow < nENROW ;
                        .AND. nMouseCol > nENCOL .AND. nMouseCol < nENCOL+4
      nSaveElement := nElement
      nElement := DC_SCRLVMOU ( nSTROW+1, nENROW-1, nMouseRow, 0, ;
                                nLENGTH, nElement, 1, nInkey=-101 )
      IF nElement#nSaveElement
        lPaintScrn := .t.
        DC_INKEYRELE( .15, nSTROW+1, nENCOL+1, nENROW-1, nENCOL+3 )
      ENDIF

    CASE nInkey <= -101 .AND. !EMPTY(DC_MOUSEKEY(aHotKeys,,,;
                                    nMouseRow, nMouseCol ))

    CASE nInkey <= -101 .AND. lMOUSEEXIT .AND. ( nMouseRow < nSTROW ;
                        .OR. nMouseRow > nENROW .OR. nMouseCol > nENCOL .OR. ;
                             nMouseCol < nSTCOL )
      nElement := 0
      EXIT

    CASE cCode $ cBarHotKeys .AND. Valtype(aMenu)='A'
      DC_MenuMain( aMenuMain, cCode )
      cScanString := ''

    CASE Valtype(aMenu)='A' .AND. LEN(aMenu)>=18 .AND.;
         DC_MenuAccel(aMenu[18],nInkey)

    CASE nInkey = K_UP
      IF nElement > 1
        nElement --
        DO WHILE nElement>1
          IF (VALTYPE(aSelectItems[nElement])='L' .AND. ;
             !(aSelectItems[nElement])) .OR. ;
            (VALTYPE(aSelectItems[nElement])='C' .AND. ;
             !(&(aSelectItems[nElement])))
             nElement--
          ELSE
            EXIT
          ENDIF
        ENDDO
      ELSE
        nState := AC_HITTOP
        nInkey := 0
      ENDIF
      cScanString := ''

    CASE nInkey = K_DOWN
      IF nElement < nLENGTH
        nElement++
        DO WHILE nElement<=nLENGTH
          IF (VALTYPE(aSelectItems[nElement])='L' .AND. ;
             !(aSelectItems[nElement])) .OR. ;
            (VALTYPE(aSelectItems[nElement])='C' .AND. ;
             !(&(aSelectItems[nElement])))
             nElement++
          ELSE
            EXIT
          ENDIF
        ENDDO
      ELSE
        nState := AC_HITBOTTOM
        nInkey := 0
      ENDIF
      cScanString := ''

    CASE nInkey = K_PGUP
      IF nElement > 1
        nElement := nElement - (nENROW-nSTROW)
        nWinStart := nWinStart - (nENROW-nSTROW)
        lPaintScrn := .t.
        DO WHILE nElement>1
          IF (VALTYPE(aSelectItems[nElement])='L' .AND. ;
             !(aSelectItems[nElement])) .OR. ;
            (VALTYPE(aSelectItems[nElement])='C' .AND. ;
             !(&(aSelectItems[nElement])))
             nElement--
          ELSE
            EXIT
          ENDIF
        ENDDO
      ELSE
        nState := AC_HITTOP
        nInkey := 0
      ENDIF
      cScanString := ''

    CASE nInkey = K_PGDN
      IF nElement < nLENGTH
        nElement := nElement + (nENROW-nSTROW)
        nWinStart := nWinStart + (nENROW-nSTROW)
        lPaintScrn := .t.
        DO WHILE nElement<=nLENGTH
          IF (VALTYPE(aSelectItems[nElement])='L' .AND. ;
             !(aSelectItems[nElement])) .OR. ;
            (VALTYPE(aSelectItems[nElement])='C' .AND. ;
             !(&(aSelectItems[nElement])))
             nElement++
          ELSE
            EXIT
          ENDIF
        ENDDO
      ELSE
        nState := AC_HITBOTTOM
        nInkey := 0
      ENDIF
      cScanString := ''

    CASE nInkey = K_HOME .OR. nInkey = K_CTRL_PGUP
      nElement := 1
      nWinStart := 1
      lPaintScrn := .t.
      cScanString := ''

    CASE nInkey = K_END .OR. nInkey = K_CTRL_PGDN
      nElement := nLENGTH
      nWinStart := nLENGTH-(nENROW-nSTROW)
      lPaintScrn := .t.
      cScanString := ''

    CASE nInkey = K_CTRL_HOME
      nElement := nWinStart
      cScanString := ''

    CASE nInkey = K_CTRL_END
      nElement := nWinStart + (nENROW-nSTROW)
      cScanString := ''

    CASE nInkey = K_ESC // (.OR. nInkey = K_RIGHT .OR. nInkey = K_LEFT)
      nElement := 0
      EXIT

    CASE nInkey = K_ENTER
      EXIT

    CASE EMPTY(cUserFunction) .OR. nUdfReturn = AC_GOTO
      nSaveElement := nElement
      nStartScan := nElement
      cScanString += CHR(nInkey)
      DO WHILE nStartScan < nLENGTH
        nElement := ASCAN(aMenuItems,cScanString,nStartScan+1)
        IF nElement = 0
          nElement := ASCAN(aMenuItems,UPPER(cScanString),nStartScan+1)
          IF nElement = 0
            nElement := ASCAN( aMenuItems,cScanString,1)
            IF nElement = 0
              nElement := ASCAN( aMenuItems,UPPER(cScanString),1)
            ENDIF
          ENDIF
        ENDIF
        IF nElement = 0
          cScanString := ''
          nElement := nSaveElement
        ELSE
          IF (VALTYPE(aSelectItems[nElement])='L' .AND. ;
             !(aSelectItems[nElement])) .OR. ;
            (VALTYPE(aSelectItems[nElement])='C' .AND. ;
             !(&(aSelectItems[nElement])))
            nStartScan := nElement
            LOOP
          ENDIF
        ENDIF
        EXIT
      ENDDO

    OTHERWISE
      nState := AC_EXCEPT

  ENDCASE

ENDDO
IF lSCROLLBAR .AND. lRESTSCREEN
  DC_IMPLODE( cSaveScrn )
ENDIF
IF Valtype(nSaveCurRow) = 'N'
  SetPos( nSaveCurRow, nSaveCurCol )
  SETCOLOR(cSaveColor)
  SET(_SET_CURSOR,nCursor)
ENDIF
DC_INKEYRELE(0)
RETURN nElement

* -----------------

FUNCTION dc_readapick ( xValue, aPickList, nStRow, nStCol, nEnRow, nEnCol, ;
                        lAccept, lSetExact, lStringList, nSubList, lAddToGet, ;
                        cTitle )

LOCAL oGet, nPos, cSaveScrn, aChoice, i, aValid, lExact, aList, ;
      nLength, oXbp := SetAppFocus()

lAccept     := IIF(Valtype(lAccept)='L',lAccept,.f.)
lSetExact   := IIF(Valtype(lSetExact)='L',lSetExact,.t.)
lStringList := IIF(Valtype(lStringList)='L',lStringList,.f.)
lAddtoGet   := IIF(Valtype(lAddToGet)='L',lAddToGet,.f.)
oGet := DC_GetActive()
IF Valtype(aPickList) = 'B'
  aPickList := Eval(aPickList)
ELSEIF Valtype(aPickList) = 'C'
  aPickList := { aPickList }
ENDIF
IF EMPTY( aPickList )
  RETURN .f.
ENDIF
IF Valtype( nSubList ) = 'N'
  aList := aPickList[nSubList]
ELSE
  aList := aPickList
ENDIF
IF LEN(aList)=0
  RETURN .t.
ENDIF
IF VALTYPE(aList[1]) = 'A'
  aValid := DC_ACONVERT( aList )
ELSE
  aValid := { aList, aList, nil }
ENDIF
ASIZE(aValid,3)
nPos := 0
lExact := SET(_SET_EXACT, lSetExact )
IF lStringList
  IF EMPTY(xValue) .AND. oGet:exitState#MOUSE_ENTER
    SET(_SET_EXACT,lExact)
    RETURN .t.
  ENDIF
  FOR i := 1 TO LEN(TRIM(xValue))
    nPos := ASCAN( aValid[1], SUBSTR( xValue,i,1 ) )
    IF nPos > 0 .AND. oGet:exitstate#MOUSE_ENTER
      SET(_SET_EXACT,lExact)
      RETURN .t.
    ENDIF
  NEXT
ELSE
  nPos := ASCAN( aValid[1], xValue )
ENDIF
SET(_SET_EXACT,lExact)

IF nPos > 0 .AND. !DC_GetEditPick()
  RETURN .t.
ENDIF

nLength := _DCReadALen(aValid)
IF DC_Gui()
  nStRow := 6
  nStCol := 30
ELSE
  nStRow := IIF(Valtype(nStRow)='N',nStRow,oGet:row)
  nStCol := IIF(Valtype(nStCol)='N',nStCol,oGet:col+2)
ENDIF
nEnRow := IIF(Valtype(nEnRow)='N',nEnRow,nStRow+LEN(aValid[1])+3)
nEnCol := IIF(Valtype(nEnCol)='N',nEnCol,nStCol+6+nLength)
IF SetAppWindow():ClassName() = 'XbpCrt'
  IF nEnRow > MaxRow()
    nEnRow := MaxRow()
    IF nStRow < 0
      nStRow := 0
    ENDIF
  ENDIF
  IF nEnCol > MaxCol()
    nEnCol := Col()-5
    nStCol := nEnCol-nLength-3
    IF nStCol < 0
      nStCol := 0
    ENDIF
  ENDIF
ENDIF

nEnRow := MIN(nEnRow,DC_MaxRow())
nEnCol := MIN(nEnCol,DC_MaxCol())
aChoice := ARRAY(LEN(aValid[2]))
FOR i := 1 TO LEN(aChoice)
  aChoice[i] := TRANSFORM(aValid[2,i],'@S')
NEXT
IF nPos = 0
  nPos := 1
ENDIF

nPos := DC_Achoice( nStrow,nStCol,nEnRow,nEnCol,aChoice,,,nPos,,, ;
                    {.t.,,cTitle},aValid[3] )
IF nPos>0
  xValue := aValid[1,nPos]
  IF lAccept
    DC_PUTKEY( K_ENTER )
  ENDIF
ENDIF
IF !DC_ReadProtected( oGet ) .AND. VALTYPE(oGet:buffer)='C'
  IF lStringList .OR. lAddToGet
    IF !(xValue $ oGet:buffer)
      oGet:buffer := PAD(TRIM(oGet:buffer)+xValue,LEN(oGet:buffer))
    ENDIF
  ELSE
    oGet:buffer := PAD(xValue,LEN(oGet:buffer))
  ENDIF
  IF DC_Gui()
    oGet:SetEditBuffer(oGet:buffer)
    IF Empty(oGet:picture)
      oGet:picture := ''
    ENDIF
    Eval(oGet:datalink,Transform(xValue,oGet:picture))
    oGet:SetData()
  ELSE
    oGet:_assign()
  ENDIF
ENDIF
oGet:exitState := MOUSE_ENTER
SetAppFocus(oXbp)
DC_INKEYRELE(0)
RETURN .t.

* -----------------

FUNCTION dc_guireadapick ( xValue, aPickList, nStRow, nStCol, nEnRow, nEnCol, ;
                           lAccept, lSetExact, lStringList, nSubList, lAddToGet, ;
                           cTitle, oGet, oGet2 )

LOCAL nPos, cSaveScrn, aChoice, i, aValid, lExact, aList, ;
      nLength, oXbp := SetAppFocus(), lGui, lPopup

lAccept     := IIF(Valtype(lAccept)='L',lAccept,.f.)
lSetExact   := IIF(Valtype(lSetExact)='L',lSetExact,.t.)
lStringList := IIF(Valtype(lStringList)='L',lStringList,.f.)
lAddtoGet   := IIF(Valtype(lAddToGet)='L',lAddToGet,.f.)

IF Valtype(oGet2) == 'O'
  oGet := oGet2
ENDIF

lGui := Valtype(oGet) == 'O'
lPopup := oGet:exitState == MOUSE_ENTER
oGet:exitState := 0

IF Valtype(aPickList) = 'B'
  aPickList := Eval(aPickList)
ELSEIF Valtype(aPickList) = 'C'
  aPickList := { aPickList }
ENDIF
IF EMPTY( aPickList )
  RETURN .f.
ENDIF
IF Valtype( nSubList ) = 'N'
  aList := aPickList[nSubList]
ELSE
  aList := aPickList
ENDIF
IF LEN(aList)=0
  RETURN .t.
ENDIF
IF VALTYPE(aList[1]) = 'A'
  aValid := DC_ACONVERT( aList )
ELSE
  aValid := { aList, aList, nil }
ENDIF
ASIZE(aValid,3)
nPos := 0
lExact := SET(_SET_EXACT, lSetExact )
IF lStringList
  IF EMPTY(xValue) .AND. !lPopUp
    SET(_SET_EXACT,lExact)
    RETURN .t.
  ENDIF
  FOR i := 1 TO LEN(TRIM(xValue))
    nPos := ASCAN( aValid[1], SUBSTR( xValue,i,1 ) )
    IF nPos > 0 .AND. !lPopUp
      SET(_SET_EXACT,lExact)
      RETURN .t.
    ENDIF
  NEXT
ELSE
  nPos := ASCAN( aValid[1], xValue )
ENDIF
SET(_SET_EXACT,lExact)

IF nPos > 0 .AND. !lPopUp
  RETURN .t.
ENDIF

nLength := _DCReadALen(aValid)
nStRow := 6
nStCol := 30
nEnRow := IIF(Valtype(nEnRow)='N',nEnRow,nStRow+LEN(aValid[1])+3)
nEnCol := IIF(Valtype(nEnCol)='N',nEnCol,nStCol+6+nLength)
IF nEnRow - nStRow > 22
  nEnRow := nStRow + 22
ENDIF
aChoice := ARRAY(LEN(aValid[2]))
FOR i := 1 TO LEN(aChoice)
  aChoice[i] := TRANSFORM(aValid[2,i],'@S')
NEXT
IF nPos = 0
  nPos := 1
ENDIF

nPos := DC_Apick ( nStRow, nStCol, nEnCol - nStCol, nEnRow - nStRow, aChoice, ;
                   cTitle, nil, cTitle, nil, nil, nil, nil, nil, nil, nil, .T. )

IF nPos>0
  xValue := aValid[1,nPos]
  IF lAccept
    DC_PUTKEY( K_ENTER )
  ENDIF
ENDIF
IF !DC_ReadProtected( oGet ) .AND. VALTYPE(oGet:buffer)='C'
  IF lStringList .OR. lAddToGet
    IF !(xValue $ oGet:buffer)
      oGet:buffer := PAD(TRIM(oGet:buffer)+xValue,LEN(oGet:buffer))
    ENDIF
  ELSE
    oGet:buffer := PAD(xValue,LEN(oGet:buffer))
  ENDIF
  oGet:SetEditBuffer(oGet:buffer)
  IF Empty(oGet:picture)
    oGet:picture := ''
  ENDIF
  oGet:_assign(xValue)
ENDIF
oGet:exitState := 0
SetAppFocus(oXbp)
RETURN .t.

* ------------------

STATIC FUNCTION _DCReadALen ( aValid )

LOCAL nLength := 0, i
FOR i := 1 TO LEN( aValid[2] )
  nLength := Max(nLength,LEN(TRANSFORM(aValid[2,i],'@S')))
NEXT
RETURN nLength

* --------------------

FUNCTION dc_guiachoice ( nTop, nLeft, nBottom, nRight, aMenuItems, ;
                         aSelectItems, cUserFunction, nElement,;
                         nWinStart, cTitle, aHelpCodes, aMenu,;
                         cFontName, oDlg, lDestroy, aMessage, cHeader, ;
                         lCenter, lModal )

LOCAL nEvent, oXbp, mp1, mp2, aArray, i, nWidth, nHeight, oParent, oOwner, ;
      oAppFocus := SetAppFocus(), lWinStart, oAppWindow := SetAppWindow(), ;
      cChar

DEFAULT cFontName := '8.Courier', ;
        lDestroy := .t., ;
        lCenter := .f., ;
        nWinStart := 1, ;
        lModal := .f.


* msgbox("COBA")

aArray := { aMenuItems, 1 }

IF Valtype(oDlg)#'O'

  oParent := AppDeskTop()
  oOwner  := SetAppWindow()
  nWidth  := nRight - nLeft
  nHeight := nBottom - nTop
  nTop := oParent:currentSize()[2]-nHeight-nTop

  oDlg := XbpDialog():new( oParent, oOwner, ;
                      { nLeft, nTop },{ nWidth + 20, nHeight + 20 },, .F. )

  * nLeft - distance from the left side of the monitor / pixels
  * nTop  - distance from the bottom row of monitors   / pixels

  IF Valtype(DC_IconDefault())$'NO'
    oDlg:icon := DC_IconDefault()
  ENDIF


  oDlg:sysmenu := .t.
  oDlg:taskList := .t.
  oDlg:minbutton := .f.
  oDlg:maxbutton := .f.
  oDlg:title    := cTitle
  oDlg:drawingArea:setFontCompoundName( cFontName )
  oDlg:create()

  IF lModal
    oDlg:SetModalState(XBP_DISP_APPMODAL)
  ENDIF

  IF lCenter
    DC_CenterObject(oDlg,SetAppWindow())
  ENDIF

  SetAppWindow(oDlg)

  IF Valtype(aMenu) = 'A'
    // Install menu on Dialog window
    DC_MenuOSys( aMenu, oDlg, .f. )
  ENDIF

  IF Valtype(aMessage)='A'
    FOR i := 1 TO LEN(aMessage)
      oXbp := XbpStatic():new( oDlg:drawingArea, , ;
              { 20,nHeight-(i*17)-34 },{nWidth-7,15} )
      oXbp:caption := aMessage[i]
      oXbp:autosize := .t.
      oXbp:create()
    NEXT
    nTop += LEN(aMessage)*17 + 25
  ENDIF

  // The browse is resized to fill the entire window
  oDlg:drawingArea:resize := ;
      {|mp1,mp2,obj| obj:childList()[1]:setSize(mp2) }

  oDlg:cargo := ;
    XbpBrowse():new( oDlg:drawingArea,,,{nWidth-7, nHeight-30}, ;
                      DC_GuiBrowParam() ):create()

  oDlg:cargo:setFontCompoundName( cFontName )
  oDlg:cargo:cargo         := aArray
  oDlg:cargo:skipBlock     := {|n,obj| SkipArray( n, obj:cargo ) }
  oDlg:cargo:goTopBlock    := {|obj| obj:cargo[2] := 1 }
  oDlg:cargo:goBottomBlock := {|obj| obj:cargo[2] := Len( obj:cargo[ 1 ] ) }
  oDlg:cargo:posBlock      := {|obj| obj:cargo[2] }
  oDlg:cargo:phyPosBlock   := {|obj| obj:cargo[2] }
  oDlg:cargo:lastPosBlock  := {|obj| Len( obj:cargo[1] ) }
  oDlg:cargo:firstPosBlock := {|obj| 1  }

  oDlg:cargo:softTrack := .f.
  oDlg:cargo:addColumn( {||aArray[1,aArray[2]]}, (nRight-nLeft)/7, cHeader )

  IF lWinStart := ( Valtype(nWinStart) = 'N' .AND. nWinStart > 0 .AND. ;
                    nWinStart <= Len(aMenuItems) )
    oDlg:cargo:cargo[2] := nWinStart
    oDlg:cargo:show()
    oDlg:cargo:refreshAll()
  ENDIF
  IF Valtype(nElement) = 'N' .AND. nElement > 0 .AND. nElement <= Len(aMenuItems)
    IF lWinStart
      FOR i := 1 TO nElement - nWinStart
        oDlg:cargo:down()
      NEXT
    ELSE
      oDlg:cargo:cargo[2] := nElement
      oDlg:cargo:show()
      oDlg:cargo:refreshAll()
    ENDIF
  ENDIF

  // Display window
  oDlg:show()

  // Display browser.
  oDlg:cargo:show()
  oDlg:cargo:refreshAll()

ELSE

  oDlg:cargo:refreshcurrent()

ENDIF

// Set focus to browser
SetAppFocus( oDlg )
SetAppFocus( oDlg:cargo:GetColumn(1) )

nElement := 0

// Event loop
DO WHILE nEvent <> xbeP_Close
  nEvent := AppEvent( @mp1, @mp2, @oXbp, 1 )
  IF Valtype(oXbp) = 'O'
    oXbp:handleEvent( nEvent, mp1, mp2 )
  ENDIF
  nElement := oDlg:cargo:cargo[2]
  IF nEvent = xbeP_Keyboard .AND. (oXbp==oDlg:cargo .OR. oXbp==oDlg .OR. oXbp==oDlg:cargo:GetColumn(1))
    IF mp1 = K_ENTER
      DC_ClearEvents()
      EXIT
    ELSEIF mp1 = K_ESC
      nElement := 0
      EXIT
    ENDIF
    cChar := Upper(Chr(mp1))
    IF Valtype(aMenuItems) = 'A'
      nElement := AScan( aMenuItems, {|a|Upper(Left(a[1],1))==cChar}, nElement+1 )
    ENDIF
    IF nElement > 0
      oDlg:cargo:cargo[2] := nElement
      oDlg:cargo:refreshAll()
    ENDIF
  ELSEIF nEvent = xbeBRW_ItemSelected .AND. oXbp==oDlg:cargo
    EXIT
  ENDIF
ENDDO

IF nEvent == xbeP_Close
  nElement := 0
ENDIF

SetAppWindow(oAppWindow)

IF lDestroy
  IF lModal
    oDlg:SetModalState(XBP_DISP_MODELESS)
  ENDIF
  oDlg:Destroy()
ENDIF

SetAppFocus(oAppFocus)

RETURN nElement

/* ------------------------ */

STATIC FUNCTION SkipArray( nWantSkip, aArray )

LOCAL nDidSkip, nLastRec := Len( aArray[1] )

   IF aArray[2] + nWantSkip < 1              // "BoF"
      nDidSkip := 1 - aArray[2]
   ELSEIF aArray[2] + nWantSkip > nLastRec   // "EoF"
      nDidSkip := nLastRec - aArray[2]
   ELSE
      nDidSkip := nWantSkip
   ENDIF
   aArray[2] += nDidSkip

RETURN nDidSkip

* -------------------- *

FUNCTION dc_apick ( nTop, nLeft, nWidth, nHeight, aMenuItems, ;
                    acHeader, anWidth, cTitle, anTag, aTagColor, ;
                    bHandler, nStart, cFontName, oParent, ;
                    oOwner, lCenter, lMenu, lNoVScroll, lNoHScroll, aPres, ;
                    cHelpCode, cAutoSeekPicture, lNoRestore )

LOCAL aArray, aHeader, oBrowse, i, GetList := {}, GetOptions, ;
      nElement, nHeadLines := 1, aWidth, nItems, bColor, ;
      lOk, bDataLink, lMultiDim, lSetPos := .f., aRef[5], cSearch, ;
      nKey, nRow, oSearch

DEFAULT nStart := 1, ;
        nElement := nStart, ;
        cFontName := '8.Courier', ;
        lCenter := Valtype(nTop) # 'N', ;
        nTop := 0, ;
        nLeft := 0, ;
        nWidth := 30, ;
        nHeight := 12, ;
        aTagColor := { GRA_CLR_WHITE, GRA_CLR_BLUE }, ;
        lNoVScroll := .f., ;
        lNoHScroll := .f., ;
        aPres := DC_BrowPres(), ;
        lMenu := .f., ;
        lNoRestore := .f.

lMultiDim := Len(aMenuItems) >= 1 .AND. Valtype(aMenuItems[1]) = 'A'

IF lMultiDim
  aArray := aMenuItems
ELSE
  aArray := {}
  FOR i := 1 TO Len(aMenuItems)
    AAdd(aArray,{aMenuItems[i]})
  NEXT
ENDIF
nItems := Len(aArray[1])

aHeader := {}
IF Valtype(acHeader) = 'C'
  aHeader := { acHeader }
ELSEIF Valtype(acHeader) = 'A'
  aHeader := acHeader
ENDIF
ASize(aHeader,nItems)

aWidth := {}
IF Valtype(anWidth) = 'N'
  aWidth := { anWidth }
ELSEIF Valtype(anWidth) = 'A'
  aWidth := anWidth
ENDIF
ASize(aWidth,nItems)

IF Valtype(anTag) = 'A'
  bDataLink := {||anTag[nElement] := !(anTag[nElement]), ;
                  oBrowse:refreshCurrent(), oBrowse:forceStable()}
  bColor := {|n|n:=DC_GetColArray(0,oBrowse),IIF(anTag[n],aTagColor,nil)}
ELSEIF Valtype(anTag) = 'N'
  bDataLink := {||aArray[nElement,anTag] := !(aArray[nElement,anTag]), ;
                  oBrowse:refreshCurrent(),oBrowse:forceStable()}
  bColor := {|n|n:=DC_GetColArray(0,oBrowse),IIF(aArray[n,anTag],aTagColor,nil)}
ELSE
  bDataLink := {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
ENDIF

nRow := 0

IF Valtype(cAutoSeekPicture) = 'C'
  cSearch := Space(20)
  @ 0,0 DCSAY 'Search' GET cSearch PICTURE cAutoSeekPicture ;
        GETOBJECT oSearch ;
        SAYSIZE 0 ;
        SAYBOTTOM ;
        KEYBLOCK {|nKey,b,oGet|DC_BrowseAutoSeek(nKey,oGet,oBrowse,aArray)}
  nRow++
ENDIF

@ nRow,0 DCBROWSE oBrowse DATA aArray SIZE nWidth, nHeight ;
      DATALINK bDataLink ;
      NOSOFTTRACK ;
      POINTER nElement ;
      FONT cFontName ;
      ;// CURSORMODE XBPBRW_CURSOR_ROW ;
      PRESENTATION aPres ;
      HEADLINES nHeadLines ;
      _NOVSCROLL lNoVScroll ;
      _NOHSCROLL lNoHScroll

FOR i := 1 TO nItems
  IF Valtype(anTag) = 'N' .AND. i = anTag
    LOOP
  ENDIF
  DEFAULT aHeader[i] := '# ' + Alltrim(Str(i))
  IF nItems = 1 .AND. i = 1
    DEFAULT aWidth[i] := Max( nWidth, Len(DC_XtoC(aArray[1,1])) + 10 )
  ENDIF
  DCBROWSECOL ELEMENT i PARENT oBrowse HEADER aHeader[i] ;
    WIDTH aWidth[i] COLOR bColor
NEXT

aRef[1] := aArray
aRef[2] := 0
aRef[3] := lMenu
aRef[4] := nil

DCGETOPTIONS ;
   NOBUSY ;
   NOMAXBUTTON ;
   NOMINBUTTON ;
   AUTORESIZE ;
   HELPCODE cHelpCode

DCREAD GUI EXPRESS ;
   FIT ;
   ADDBUTTONS ;
   MODAL ;
   TITLE cTitle ;
   TO lOk ;
   OPTIONS GetOptions ;
   PARENT @oParent ;
   _NOAUTORESTORE lNoRestore ;
   OWNER @oOwner ;
   HANDLER PickHandler REFERENCE aRef ;
   EVAL {|o|IIF(!lCenter, ;
            o:setPos({nLeft*7,oParent:currentSize()[2]-(nTop*20)-(nHeight*20)}),nil), ;
            oBrowse:cargo[4] := nElement, ;
            IIF(IsMemberVar(oBrowse,'ArrayElement'),oBrowse:arrayElement:=nElement,nil), ;
            oBrowse:refreshAll(), ;
            SetAppFocus(IIF(Valtype(cAutoseekPicture)='C',oSearch,oBrowse:GetColumn(1))), ;
            aRef[4] := oBrowse, ;
            aRef[5] := oSearch}

IF lOk
  IF aRef[2] > 0
    nElement := aRef[2]
  ENDIF
  RETURN nElement
ENDIF

RETURN 0

* ----------------

STATIC FUNCTION PickHandler( nEvent, mp1, mp2, oXbp, oDialog, aGetList, aRef )

LOCAL aArray := aRef[1], lMenu := aRef[3], cChar, nElement, oBrowse := aRef[4], ;
      oSearch := aRef[5]

IF nEvent == xbeP_Keyboard .AND. Empty(oSearch)
  cChar := Upper(Chr(mp1))
  nElement := oBrowse:cargo[4]
  IF lMenu
    nElement := 0
  ENDIF
  nElement := AScan( aArray, {|a|Upper(Left(a[1],1))==cChar}, nElement+1 )
  IF nElement > 0
    oBrowse:cargo[4] := nElement
    IF IsMemberVar(oBrowse,'ArrayElement')
      oBrowse:arrayElement:=nElement
    ENDIF
    oBrowse:refreshAll()
    IF lMenu
      aRef[2] := nElement
      RETURN DCGUI_EXIT_OK
    ENDIF
  ENDIF
ENDIF

RETURN DCGUI_NONE
